(* use this theory for tests before Build_Isac.thy has succeeded *)
theory Test_Theory imports "$ISABELLE_ISAC/Build_Isac"
  "$ISABELLE_ISAC_POS/Tools/isac/Specify/refine"        (* setup for refine.sml   *)
begin                                                                            
ML_file "$ISABELLE_ISAC/BaseDefinitions/libraryC.sml"

section \<open>code for copy & paste ===============================================================\<close>
text \<open>
  declare [[show_types]] 
  declare [[show_sorts]]
  find_theorems "?a <= ?a"
  
  print_theorems
  print_facts
  print_statement ""
  print_theory
  ML_command \<open>Pretty.writeln prt\<close>
  declare [[ML_print_depth = 999]]
  declare [[ML_exception_trace]]
\<close>
(** )
  (@{print} {a = "dict_cond_ord ([], [])"}; EQUAL)
( **)
ML \<open>
\<close> ML \<open>
"~~~~~ fun xxx , args:"; val () = ();
"~~~~~ and xxx , args:"; val () = ();
"~~~~~ from fun xxx \<longrightarrow>fun yyy \<longrightarrow>fun zzz , return:"; val () = ();
"~~~~~ continue fun xxx"; val () = ();
(*if*) (*andalso*) (*case*) (*let*) (*in*) (*end*); (*map:*)
"xx"^ "xxx"   (*+*) (*+++*) (*isa*) (*isa2*) (**)

\<close> ML \<open> (*//----------- inserted adhoc ------------------------------------------------------\\*)
(*//------------------ inserted adhoc ------------------------------------------------------\\*)
(*\\------------------ inserted adhoc ------------------------------------------------------//*)
\<close> ML \<open> (*\\----------- inserted adhoc ------------------------------------------------------//*)

\<close> ML \<open> (*--------------locate below ~~~ fun XXXXX, asap shift into separate section above ----*)
\<close> ML \<open> (*//----------- build fun XXXXX -----------------------------------------------------\\*)
(*//------------------ build fun XXXXX -----------------------------------------------------\\*)
(*\\------------------ build fun XXXXX -----------------------------------------------------//*)
\<close> ML \<open> (*\\----------- build fun XXXXX -----------------------------------------------------//*)

\<close> ML \<open> (*//----------- setup test data for XXXXX -------------------------------------------\\*)
(*//------------------ setup test data for XXXXX -------------------------------------------\\*)
(*\\------------------ setup test data for XXXXX -------------------------------------------//*)
\<close> ML \<open> (*\\----------- setup test data for XXXXX -------------------------------------------//*)

(* final test ... ----------------------------------------------------------------------------*)

\<close> ML \<open> (*======= AVOID @{context} \<longrightarrow> ctxt except args of init_calc*)
(*//################## @ {context} within fun XXXXX ---------------------------------------\\* )
(*-------------------- there must not be > ML < inbetween-------------------------------------*)
(*-------------------- do NOT use while stepwise checking for ERRORs--------------------------*)
( *\\################# @ {context} within fun XXXXX ----------------------------------------//*)

\<close> ML \<open> (*//----------- inserted hidden code ------------------------------------------------\\*)
(*//------------------ inserted hidden code ------------------------------------------------\\*)
(*\\------------------ inserted hidden code ------------------------------------------------//*)
\<close> ML \<open> (*\\----------- inserted hidden code ------------------------------------------------//*)


(** )val calling_code =( **)
(**)val return_XXXXX =(**)
  "call XXXXX";
\<close> ML \<open> (*//----------- step into XXXXX -----------------------------------------------------\\*)
(*//------------------ step into XXXXX -----------------------------------------------------\\*)
\<close> ML \<open> (*||----------- contine.. XXXXX -------------------------------------------------------*)
(*||------------------ contine.. XXXXX -------------------------------------------------------*)
(*\\------------------ step into XXXXX -----------------------------------------------------//*)
\<close> ML \<open> (*\\----------- step into XXXXX -----------------------------------------------------//*)
val calling_code = return_XXXXX;

(*=== complete model for step into (the above is optimised wrt. quick replacement fo XXXXX)*)
(** )val calling_code =( **)
(**)val return_XXXXX =(**)
  "call XXXXX";
\<close> ML \<open> (*//----------- step into XXXXX -----------------------------------------------------\\*)
(*//------------------ step into XXXXX -----------------------------------------------------\\*)
"~~~~~ fun XXXXX , args:"; val () = ();
\<close> ML \<open> (*||----------- contine.. XXXXX -------------------------------------------------------*)
(*||------------------ contine.. XXXXX -------------------------------------------------------*)
val return_XXXXX_STEP = 123
(*\\------------------ step into XXXXX -----------------------------------------------------//*)
\<close> ML \<open> (*\\----------- step into XXXXX -----------------------------------------------------//*)
val calling_code = return_XXXXX;

(*=== rules for step into:
 * XXXXX = me_specify_step_by_tactic  ...i.e. include stucture id in identifiers
 * val return_XXXXX_STEP = return_YYYYY
   ... indicates, that the value of a called function is also the value of the calling function
 *)
\<close> ML \<open>
\<close>

section \<open>===================================================================================\<close>
section \<open>===== open struct =================================================================\<close>
ML \<open>
(** )open Refine;( * overwrites import "...Specify/refine" above, see "open Refine" in refine.sml *)
  open Store;
  open M_Match;
  open P_Model;
  open Kernel;
  open Math_Engine;
  open Test_Code;              Test_Code.init_calc @{context};
  open LItool;                 arguments_from_model;
  open Sub_Problem;
  open Fetch_Tacs;
  open Step
  open Env;
  open LI;                     scan_dn;
  open Istate;
  open Error_Pattern;
  open Error_Pattern_Def;
  open Specification;
  open Ctree;
  open Pos;
  open Program;
  open Prog_Tac;
  open Tactical;
  open Prog_Expr;
  open Auto_Prog;
  open Input_Descript;
  open Specify;
  open Specify;
  open Step_Specify;
  open Step_Solve;
  open Step;
  open Solve;
  open ContextC;
  open Tactic;
  open I_Model;
  open O_Model;
  open P_Model;
  open Rewrite;
  open Eval;
  open TermC;
  open Rule;
  open Rule_Set;
  open Eval_Def
  open ThyC
  open ThmC_Def
  open ThmC
  open Rewrite_Ord
  open UnparseC;

  Know_Store.set_ref_last_thy @{theory};
  (*otherwise ERRORs in pbl-met-hierarchy.sml, refine.sml, evaluate.sml*)
\<close>

section \<open>code for copy & paste ===============================================================\<close>
text \<open>
  declare [[show_types]] 
  declare [[show_sorts]]
  find_theorems "?a <= ?a"
  
  print_theorems
  print_facts
  print_statement ""
  print_theory
  ML_command \<open>Pretty.writeln prt\<close>
  declare [[ML_print_depth = 999]]
  declare [[ML_exception_trace]]
\<close>
ML \<open>
\<close> ML \<open>
"~~~~~ fun xxx , args:"; val () = ();
"~~~~~ and xxx , args:"; val () = ();
"~~~~~ fun xxx recursive, args:"; val () = ();
(*if*) (*then*); (*else*); (*andalso*)  (*case*)  (*in*) (*end*);
"xx"
^ "xxx"   (*+*) (*+++*)  (*isa*) (*isa2*) (**);
val return_XXXXX = "XXXXX"
\<close> ML \<open> (*//----------- step into XXXXX -----------------------------------------------------\\*)
(*//------------------ step into XXXXX -----------------------------------------------------\\*)
\<close> ML \<open> (*||----------- contine-- XXXXX -------------------------------------------------------*)
(*||------------------ contine-- XXXXX -------------------------------------------------------*)
(*\\------------------ step into XXXXX -----------------------------------------------------//*)
\<close> ML \<open> (*\\----------- step into XXXXX -----------------------------------------------------//*)
val "XXXXX" = return_XXXXX;

(* final test ... ----------------------------------------------------------------------------*)

\<close> ML \<open> (*//----------- build fun XXXXX -----------------------------------------------------\\*)
(*//------------------ build fun XXXXX -----------------------------------------------------\\*)
(*\\------------------ build fun XXXXX -----------------------------------------------------//*)
\<close> ML \<open> (*\\----------- build fun XXXXX -----------------------------------------------------//*)

\<close> ML \<open> (*//----------- inserted hidden code ------------------------------------------------\\*)
(*//------------------ inserted hidden code ------------------------------------------------\\*)
(*\\------------------ inserted hidden code ------------------------------------------------//*)
\<close> ML \<open> (*\\----------- inserted hidden code ------------------------------------------------//*)

\<close> ML \<open> (*//----------- setup test data for XXXXX -------------------------------------------\\*)
(*//------------------ setup test data for XXXXX -------------------------------------------\\*)
(*\\------------------ setup test data for XXXXX -------------------------------------------//*)
\<close> ML \<open> (*\\----------- setup test data for XXXXX -------------------------------------------//*)
\<close>

section \<open>===================================================================================\<close>
section \<open>=====  ============================================================================\<close>
ML \<open>
\<close> ML \<open>

\<close> ML \<open>
\<close>

(** )ML_file "$ISABELLE_ISAC/Specify/refine.sml"( **)
section \<open>===================================================================================\<close>
section \<open>===== new code xxxxx ==============================================================\<close>
ML \<open>
\<close> ML \<open>

\<close> ML \<open>
\<close>

section \<open>===================================================================================\<close>
section \<open>=====  ============================================================================\<close>
ML \<open>
\<close> ML \<open>

\<close> ML \<open>
\<close>

section \<open>===================================================================================\<close>
section \<open>=====  ============================================================================\<close>
ML \<open>
\<close> ML \<open>

\<close> ML \<open>
\<close>

section \<open>===================================================================================\<close>
section \<open>===== work with Test_Theory =======================================================\<close>
text \<open>
in Test_Theory
(1) create test code in Test_Theory or copy from test/*
    provide a rather complete selection of tests with respect to the envisaged update
    balance size of the selection with efforts due to multiple updates in (8.3)
(2) ALL functions under consideration come into a section "NEW code" above the test code
    remember the source of each function with (*--> xxx.sml*)
(3) in case there are "open Struct", these must be ABOVE section "NEW code",
    opens located below might cover the NEW code in the NEW code
(4) hide ALL (*Struct.*) functions under consideration
    thus you avoid side effects to the old code
(5) update the NEW code with marker (*OLD*) (*---*) (*NEW*)
    do NOT overwrite the old code
(6) update the test code according to the NEW code
    until the test code works

from Test_Theory to src/*
    copy step-wise from top to down functions of the NEW code to src/*
(7) at each step
  (7.1) copy functions from the NEW code to src/* including (*OLD*) (*---*) (*NEW*)
        that helps with backtracking after too complicated errors
  (7.2) out-comment the NEW function in section "NEW code"
  (7.3) keep Test_Theory.thy without errors: uncomment "(*Struct.*)" in NEW code AND test code
  (7.4) out-comment with (*OLD* )out-commented( *---*) (*NEW*) in src/*
        that avoids calls to updated functions (probably step with a bundle of functions)
  (7.5) keep Build_Isac.thy without errors
  (7.6) keep the tests in Test_Theory.thy while updating Test_Isac.thy
        this helps with recurring errors in NEW code
  (7.7) change code updates by use of Hypersearch over isa/src AND isa/test
  (7.8) "hg commit -m rollback" after each successful step
        check "hg tip" and dont forget to do "hg rollback" first
(8) call certain tests in Build_Isac.thy to make side effects of errors visible
(9) add the test code somewhere to test/* in case the test is new

in test/*
    probably reduce the call level to the functionality under consideration

(10) after Build_Isac.thy and Test_Isac.thy are without errors
    remove (*OLD* )out-commented( *---*) AND (*NEW*)
\<close>
end
